//////////////////////////////////////////////////////////////////
// 28.05.1996 // taptp0 // Busy soft: TAP -> 000 konvertor 1.04a //
//////////////////////////////////////////////////////////////////

/*
This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.
See the GNU General Public License for more details (http://www.gnu.org/).
*/

#include <ctype.h>
#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include "endian-compat.h"

#define lenbuf 16384
unsigned char body[lenbuf+2];

void pomoc(int x, char *name)
{printf(
"\nZX Spectrum TAP=>000 format convertor 1.04a (c) 1996 Busy soft\n"
"Linux port and safe endian correction      (c) 2002 Tritol\n");

if(x<2){printf(
"\n  Usage: %s [-l] file1 [file2 ...]\n"
"    Converts input files in TAP format into 000 file format.\n"
"    Option: -l ... creates long filenames\n"
"    You can use wildcards '*' and '?' in filename parameters.\n"
"    Extension of output files will be three-digit number.\n\n"

"This program is free software; you can redistribute it and/or modify it under\n"
"the terms of the GNU General Public License as published by the Free Software\n"
"Foundation; either version 2 of the License, or (at your option) any later\n"
"version.\n\n"

"This program is distributed in the hope that it will be useful, but WITHOUT ANY\n"
"WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A\n"
"PARTICULAR PURPOSE.\n"
"See the GNU General Public License for more details (http://www.gnu.org/).\n", name);

exit(1);}}

///////// Chybove hlasenia ////////////////////////////////
void uneof(void)
  {printf("Error: unexpected end of file.\n");}
void cantread(void)
  {printf("Error: Can't read\n");}
int testclose(int fd,char *meno)
  {fd = close(fd);if (fd<0) printf("Error: Can't close file %s\n",meno);
  return(fd);}

///////// Zapis do suboru a test spravnosti zapisu /////////
int zapis(int fd, unsigned char *buff, int kolko, char *subor)
{
  if (write(fd,buff,kolko) == kolko) return 0;
  else {printf("Can't write into %s\n",subor);return 1;}
}

///////// Prevod ZXmena na PCmeno //////////////////////////
void zxtopc(unsigned char *name, int longnames)
{
  unsigned char *nn;
  // Nahrada koncovych medzier nulami
  for (nn=name+(longnames?9:7),*(nn+1)=0;(name!=nn)&&(*nn==32);nn--) *nn=0;
  // Nahrada nahrada nekoncovych nul medzerami
  for (;nn>=name;nn--) if (*nn==0) *nn=32;
  // Filtracia ilegalnych znakov
  for (nn=name;*nn;nn++)
    if  ((*nn<33)
      || (*nn>126)
      || (strchr("*\"+,./:;<=>?[\\]|",*nn)) ) *nn='_';
}

/////////// Vytvori novy subor MENO.XYZ, xyz=000..999 //////
int novysubor (char *meno)
{
  int a,b;
  char *mm;
  mm=meno+strlen(meno);
  for (a=0,b=-1;(a<1000)&&(b<0);a++)
    {
    sprintf(mm,".%03d",a);
    b=open(meno,O_WRONLY|O_CREAT|O_EXCL,0644);
    }
  return(b);
}

///////// Hlavna funkcia programu //////////////////////////
int main(int argc, char *argv[])
{
  unsigned char head[30];
  char chyba,meno[100];
  int fdi,fdo,a,b,c,tapfiles,nulfiles,zmaz;
  unsigned len,hll;
  int ls,taplen,poz;
  char *mm,subor[100];
  struct stat filestat;
  int args,longnames;

  pomoc(argc, argv[0]);
 
  args=1;longnames=0;
  if (!strcmp(argv[1],"-l")) {args=2;longnames=1;}

  tapfiles=0;nulfiles=0;
  for (a=args;a<argc;a++)
    {
    strcpy(subor,argv[a]);
    for(mm=subor+strlen(subor);(mm!=subor)&&(*mm!='/');mm--);
    if (*mm=='/') mm++;
    fdi=open(subor,O_RDONLY);
    if (fdi<0) {printf("Can't open file %s\n",subor);continue;}
    if (stat (subor, &filestat))
      {printf("Can't get size of %s, skipping\n",subor);close(fdi);continue;}
    chyba=0;
    tapfiles++;
    taplen = (int)filestat.st_size;
    printf("\nConverting file: %s (length %d bytes)\n",mm,taplen);

    while(taplen > (poz = (int)lseek(fdi, 0, SEEK_CUR)))
      {
      printf("%6d\t",poz);
      b = read(fdi,head,3);
      if (b < 3) {uneof();chyba=1;break;}
      len = FROM_SHORT(head);
      ls = poz-1l+len;
      if (ls > taplen) {uneof();chyba=1;break;}
      if (len < 2)
        {printf("Error: Data integrity corrupted\n");chyba=1;break;}

      if ((len!=19)||(head[2])!=0)           // Bezhlavickove telo //
        {
        printf("headerless ... %5u ",len-2); len--;
        strcpy(meno,"headless");
        fdo = novysubor(meno);
        if (fdo<0)
          {
          printf("Can't open %s\n",meno);
          lseek(fdi,len,SEEK_CUR);continue;
          }
        printf("=> %s (%u)\n",meno,len+2);
        head[1]=255;
        zmaz = zapis(fdo,head+1,2,meno);
        }
      else                    // Telo s hlavickou //
        {
        b = read(fdi,head+3,18);
        if (b < 18) {uneof();chyba=1;break;}
        for(b=4;b<14;b++) putchar(head[b]<32 ? '.' : head[b]);
        hll = FROM_SHORT(head+14);
        printf(" ... %5u ",hll);
        ls = (int)lseek(fdi, 0, SEEK_CUR);
        b = read(fdi,body,3);
        if (b < 3) {uneof();chyba=1;break;}
        len = FROM_SHORT(body);
        if ((hll != len-2)||(body[2] != 255))
          {
          puts("Error: Not match with body");
          lseek(fdi,ls,SEEK_SET);continue;
          }
        len--;
        ls = (int)lseek(fdi, 0, SEEK_CUR)+len;
        if (ls > taplen) {uneof();chyba=1;break;}
        memcpy(meno,head+4,10);
        zxtopc((unsigned char *)meno,longnames);
        fdo = novysubor(meno);
        if (fdo<0)
          {
          printf("Can't open %s\n",meno);
          lseek(fdi,len,SEEK_CUR);continue;
          }
        printf("=> %s (%u)\n",meno,len+21);
        head[1]=0;head[21]=body[2];
        zmaz = zapis(fdo,head+1,21,meno);
        }         // Koniec velkeho ifu //

      while(len)      // Skopirovanie samotneho obsahu //
        {
        c = len>lenbuf ? lenbuf : len;
        b = read(fdi,body,c);
        if (b < c) {uneof();chyba=1;zmaz=1;break;}
        zmaz |= zapis(fdo,body,b,meno);
        len -= c;
        }
      zmaz |= len;
      zmaz |= testclose(fdo,meno);
      if (zmaz) unlink(meno); else nulfiles++;
      }
    if (!chyba) printf("%6d\tEnd of file %s\n",(int)lseek(fdi, 0, SEEK_CUR),mm);
    close(fdi);
    }
  printf("\nDone. There was convert %d TAP file(s) into %d file(s) 000.\n", tapfiles,nulfiles);
  return(0);
}
